var gNameArc;			    // Arc pointing to Name field in bookmarks
var selectedFolderId;		    // The ID of the folder selected by the user
var defaultFeed;		    // The ID of the feed that the user wants to start with
var prefFolder;			    // The folder name as set in preferences
var prefUpdateInterval;		    // Update interval as set in preferences
// var prefSortReverse;		    // Sorting order as set in preferences
var prefOpenInNew;		    // Display settings as set in preferences
var prefShowContext;
var prefUserStylesheet;
var prefDefaultFeed;
var prefAlterUA;
var prefOpenWithFeed;
var prefRequestTimeout;
var menuList;			    // The pulldown menulist in the dialog
var updateIntervalElement;	    // The text box containing the update interval
var openInNewElement;
var showDetailsElement;
var showContextElement;
var userStylesheetElement;
var openWithFeedElement;
var alterUAElement;
var requestTimeoutElement;
var strbundle;

if (NC_NS == undefined) {var NC_NS = "http://home.netscape.com/NC-rdf#";}
if (WEB_NS == undefined) {var WEB_NS = "http://home.netscape.com/WEB-rdf#";}
if (RDF_NS == undefined) {var RDF_NS = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";}
if (XUL_NS == undefined) {var XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";}

// The main window's subscriptions tree passed to us as an argument
var bTree;
var caller = window.opener;

bTree = window.arguments[0];

function doCancel() {
    return;
}


function descendFolder(aPopup, aFolder, aDepth) {
    RDFC.Init(BMDS, aFolder);

    var children = RDFC.GetElements();
    while (children.hasMoreElements()) {
	var curr = children.getNext();
	if (RDFCU.IsContainer(BMDS, curr)) {
	    curr = curr.QueryInterface(Components.interfaces.nsIRDFResource);
	    var element = document.createElementNS(XUL_NS, "menuitem");
	    var name = BMDS.GetTarget(curr, gNameArc, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	    var indentation = new Array(aDepth + 1).join("  ");
	    element.setAttribute("label", indentation + name);
	    element.setAttribute("id", curr.Value);
	    aPopup.appendChild(element);
	    if (curr.Value == prefFolder) {
		// This item is currently set in prefs as the preferred folder
		// select it
		menuList.selectedItem = element;
		selectedFolderId = prefFolder;
	    }
	    descendFolder(aPopup, curr, ++aDepth);
	    --aDepth;
	}
    }
}


function doOK() {
    // Find out which element was selected in bookmarksFeedsFolderMenu
    menuList = document.getElementById("bookmarkFeedsFolder");
    updateIntervalElement = document.getElementById("update-interval");
    openInNewElement = document.getElementById("open-in-new");
    showDetailsElement = document.getElementById("show-details");
    showContextElement = document.getElementById("show-context");
    userContentElement = document.getElementById("user-stylesheet");
    userContentElement = document.getElementById("user-stylesheet");
    alterUAElement = document.getElementById("alter-useragent");
    openWithFeedElement = document.getElementById("open-with-feed");
    requestTimeoutElement = document.getElementById("request-timeout");

    var menuSelectedElement = menuList.selectedIndex;
    var updateIntervalSet = parseInt(updateIntervalElement.value);
    var requestTimeoutVal = parseInt(requestTimeoutElement.value);

    if (menuSelectedElement <= 0) {
	// User has not selected a bookmarks folder
	alert(strbundle.GetStringFromName("errnofolderselected"));
	return false;
    } else  {
	if (updateIntervalSet > 0 && updateIntervalSet < 100 ) {
	    try {
		// Set the preferences
		setPrefValue("extensions.habarixenu.feeds_folder", "str", selectedFolderId);
		setPrefValue("extensions.habarixenu.update_interval", "int", updateIntervalSet);
		setPrefValue("extensions.habarixenu.show_details", "bool", showDetailsElement.checked);
		setPrefValue("extensions.habarixenu.open_in_new", "bool", openInNewElement.checked);
		setPrefValue("extensions.habarixenu.show_subscribe_in_context", "bool", showContextElement.checked);
		setPrefValue("extensions.habarixenu.user_stylesheet", "bool", userStylesheetElement.checked);
		setPrefValue("extensions.habarixenu.alter_useragent", "bool", alterUAElement.checked);
		setPrefValue("extensions.habarixenu.open_with_feed", "bool", openWithFeedElement.checked);

		if (requestTimeoutVal >= 0 && requestTimeoutVal < 600) {
		    setPrefValue("extensions.habarixenu.request_timeout", "int", requestTimeoutVal);
		}

		if (caller && bTree) {
		    // Set the variables in habarixenu.js
		    caller.updateInterval = updateIntervalSet;
		    caller.showDetail = showDetailsElement.checked;
		    caller.prefRequestTimeout = requestTimeoutVal;

		    // Make the feeds tree point to the correct place
		    bTree.setAttribute("ref", selectedFolderId);
		    bTree.builder.rebuild();
		}
	    } catch(e) {
		alert(strbundle.GetStringFromName("errorsettingprefs") + " : " + e);
		return false;
	    }
	} else {
	    alert(strbundle.GetStringFromName("errbadupdateinterval"));
	    return false;
	}
    }

    return true;
}


function selectBookmarkFolder(aEvent) {
    selectedFolderId = aEvent.target.id;
}


function buildMenuFromDataSource() {
    // Initialize some stuff in chrome://communicator/content/bookmarks/bookmarks.js
    initServices();
    initBMService();

    strbundle=srGetStrBundle("chrome://habarixenu/locale/strings.properties");

    // Was any folder set as the preferred folder in prefs
    prefFolder = getPrefValue("extensions.habarixenu.feeds_folder", "str", "NC:BookmarksRoot");
    prefUpdateInterval = getPrefValue("extensions.habarixenu.update_interval", "int", 60);
    prefOpenInNew = getPrefValue("extensions.habarixenu.open_in_new", "bool", true);
    prefShowDetails = getPrefValue("extensions.habarixenu.show_details", "bool", false);
    prefShowContext = getPrefValue("extensions.habarixenu.show_subscribe_in_context", "bool", false);
    prefUserStylesheet = getPrefValue("extensions.habarixenu.user_stylesheet", "bool", false);
    prefDefaultFeed = getPrefValue("extensions.habarixenu.default_feed", "str", prefFolder);
    prefAlterUA = getPrefValue("extensions.habarixenu.alter_useragent", "bool", false);
    prefOpenWithFeed = getPrefValue("extensions.habarixenu.open_with_feed", "bool", false);
    prefRequestTimeout = getPrefValue("extensions.habarixenu.request_timeout", "int", 0);
    
    menuList = document.getElementById("bookmarkFeedsFolder");
    var menuPopup = document.getElementById("bookmarksFeedsFolderMenu");

    gNameArc = RDF.GetResource(NC_NS + "Name");

    // Remove any children menuPopup might have
    while (menuPopup.hasChildNodes()) {
	menuPopup.removeChild(menuPopup.firstChild);
    }

    var newMenuItem = document.createElementNS(XUL_NS, "menuitem");
    newMenuItem.setAttribute("label", "Bookmarks");
    newMenuItem.setAttribute("id", "NC:BookmarksRoot");
    menuPopup.appendChild(newMenuItem);

    var bookmarksRoot = RDF.GetResource("NC:BookmarksRoot");

    // Descend into this folder and read all its contents
    descendFolder(menuPopup, bookmarksRoot, 1, prefFolder);

    // Now set the update interval
    updateIntervalElement = document.getElementById("update-interval");
    updateIntervalElement.value = prefUpdateInterval;

    // Set the request timeout
    requestTimeoutElement = document.getElementById("request-timeout");
    requestTimeoutElement.value = prefRequestTimeout;

    // If tabbed browsing is properly configured disable the 'Optimize Tabbed Browsing' button
    if (getPrefValue("browser.tabs.loadInBackground", "bool", false) && getPrefValue("browser.tabs.opentabfor.middleclick", "bool", false)) {
	var tabbedBtn = document.getElementById("tabbrowsing-btn");
	tabbedBtn.disabled = true;
    }

    // Disable uninstall button if Firefox
    if (navigator.userAgent.indexOf("irefox") != -1) {
	var uninstallBtn = document.getElementById("uninstall-btn");
	uninstallBtn.disabled = true;

	var displayWizPage = document.getElementById("wizid3");
	displayWizPage.next = "wizpage5";
    }

    // Check or uncheck the Display Preference
    openInNewElement = document.getElementById("open-in-new");
    openInNewElement.checked = prefOpenInNew;

    showDetailsElement = document.getElementById("show-details");
    showDetailsElement.checked = prefShowDetails;

    showContextElement = document.getElementById("show-context");
    showContextElement.checked = prefShowContext;

    userStylesheetElement = document.getElementById("user-stylesheet");
    userStylesheetElement.checked = prefUserStylesheet;

    openWithFeedElement = document.getElementById("open-with-feed");
    openWithFeedElement.checked = prefOpenWithFeed;

    alterUAElement = document.getElementById("alter-useragent");
    alterUAElement.checked = prefAlterUA;
}


function uninstallHX() {
    if (confirm(strbundle.GetStringFromName("uninstallconfirm"))) {
	var oExtUninstall = new ExtensionUninstall("urn:mozilla:package:habarixenu");
	var success = oExtUninstall.uninstall();
	oExtUninstall.showLogDialog(true, opener);
	window.opener.close();
	window.close();
    } else {
	alert(strbundle.GetStringFromName("uninstallcancel"));
    }
}

function setTabbedBrowsing() {
    if (confirm(strbundle.GetStringFromName("settabbrowsingconfirm"))) {
	try {
	    setPrefValue("browser.tabs.loadInBackgroung", "bool", true);
	    setPrefValue("browser.tabs.opentabfor.middleclick", "bool", true);

	    var tabbedBtn = document.getElementById("tabbrowsing-btn");
	    tabbedBtn.disabled = true;

	    alert(strbundle.GetStringFromName("settabbrowsingok"));
	} catch (e) {
	    dump("setTabbedBrowsing(): Error Setting tabbed browsing " + e + "\n");
	}
    }
}


function doPage2DataValidation() {
    // Find out which element was selected in bookmarksFeedsFolderMenu
    menuList = document.getElementById("bookmarkFeedsFolder");
    updateIntervalElement = document.getElementById("update-interval");

    var menuSelectedElement = menuList.selectedIndex;
    var updateIntervalSet = parseInt(updateIntervalElement.value);

    if (menuSelectedElement <= 0) {
	// User has not selected a bookmarks folder
	alert(strbundle.GetStringFromName("errnofolderselected"));
	return false;
    }

    if (updateIntervalSet < 10 || updateIntervalSet >= 99 ) {
	alert(strbundle.GetStringFromName("errbadupdateinterval"));
	return false;
    } 
    return true;
}
